unit DesignForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, IniFiles;


type
  TDesignFrm = class(TForm)
    BasePict: TImage;
    LeftPict: TImage;
    OperPict: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ViewsMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure ViewsMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure ViewsMouseMove(Sender: TObject;  Shift: TShiftState; X, Y: Integer);

    procedure SizeMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure SizeMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure SizeMouseMove(Sender: TObject;  Shift: TShiftState; X, Y: Integer);

    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DesignFrm: TDesignFrm;
  Views:array[1..100] of TPanel;
  tek:TPanel;
  Count:integer;

  IniFile:TIniFile;
  i,j,k:integer;

  bordersize:integer;
  WinBorderColor:integer;

  mx,my,
  mx_old, my_old,
  tmp_x,tmp_y:integer;

  cellsize:integer;

  s1: TPanel;
  s2: TPanel;
  s3: TPanel;
  s4: TPanel;

  clicked_on_component:boolean;

  sizex,sizey,tmpx,tmpy:integer;

  form_click:boolean;

  mshift:boolean;

  procedure SizeCreate;
  procedure SizeFree;

implementation
uses ObjectInspector,MainForm, DEditor;

{$R *.DFM}
procedure SizeCreate;
Begin
  s1:=TPanel.Create(DesignFrm);
  s2:=TPanel.Create(DesignFrm);
  s3:=TPanel.Create(DesignFrm);
  s4:=TPanel.Create(DesignFrm);

  s1.Width:=6;
  s1.Height:=6;
  s2.Width:=6;
  s2.Height:=6;
  s3.Width:=6;
  s3.Height:=6;
  s4.Width:=6;
  s4.Height:=6;


  s1.Color:=clBlack;
  s2.Color:=clBlack;
  s3.Color:=clBlack;
  s4.Color:=clBlack;

  s1.BevelInner:=bvNone;
  s1.BevelOuter:=bvNone;
  s2.BevelInner:=bvNone;
  s2.BevelOuter:=bvNone;
  s3.BevelInner:=bvNone;
  s3.BevelOuter:=bvNone;
  s4.BevelInner:=bvNone;
  s4.BevelOuter:=bvNone;

  s1.Cursor:=crSizeNWSE;
  s2.Cursor:=crSizeNESW;
  s3.Cursor:=crSizeNESW;
  s4.Cursor:=crSizeNWSE;

  s1.Color:=clBlack;
  s2.Color:=clBlack;
  s3.Color:=clBlack;
  s4.Color:=clBlack;

  s1.hint:='1';
  s2.hint:='2';
  s3.hint:='3';
  s4.hint:='4';

  s1.OnMouseDown:=DesignFrm.SizeMouseDown;
  s1.OnMouseUp:=DesignFrm.SizeMouseUp;
  s1.OnMouseMove:=DesignFrm.SizeMouseMove;
  s2.OnMouseDown:=DesignFrm.SizeMouseDown;
  s2.OnMouseUp:=DesignFrm.SizeMouseUp;
  s2.OnMouseMove:=DesignFrm.SizeMouseMove;
  s3.OnMouseDown:=DesignFrm.SizeMouseDown;
  s3.OnMouseUp:=DesignFrm.SizeMouseUp;
  s3.OnMouseMove:=DesignFrm.SizeMouseMove;
  s4.OnMouseDown:=DesignFrm.SizeMouseDown;
  s4.OnMouseUp:=DesignFrm.SizeMouseUp;
  s4.OnMouseMove:=DesignFrm.SizeMouseMove;

  DesignFrm.InsertControl(s1);
  DesignFrm.InsertControl(s2);
  DesignFrm.InsertControl(s3);
  DesignFrm.InsertControl(s4);

End;
procedure SizeFree;
Begin
  s1.Free;
  s2.Free;
  s3.Free;
  s4.Free;
End;
procedure TDesignFrm.ViewsMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin
//
  SizeFree;
  tek:=TPanel(Sender);
  mx:=Tek.Left;
  my:=Tek.Top;

  tmp_x:=x-mx;
  tmp_y:=y-my;

//  mx_old:=mx;
//  my_old:=my;
//  mx:=((x-tmp_x)div cellsize)*cellsize;
//  my:=((y-tmp_y)div cellsize)*cellsize;

  clicked_on_component:=true;
end;
procedure TDesignFrm.ViewsMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin
  SizeCreate;
  s1.Visible:=true;
  s2.Visible:=true;
  s3.Visible:=true;
  s4.Visible:=true;
//
  Tek.Left:=mx;
  Tek.Top:=my;
  tek.Visible:=true;

  s1.Left:=mx-(s1.width div 2);
  s1.top:=my-(s1.height div 2);

  s2.Left:=mx+((TPanel(Sender).width)-(s2.Height div 2));
  s2.top:=my-(s2.height div 2);

  s3.Left:=mx-(s3.width div 2);
  s3.top:=my-(s3.height div 2)+TPanel(Sender).height;

  s4.Left:=mx+((TPanel(Sender).width)-(s4.Height div 2));
  s4.top:=my-(s4.height div 2)+TPanel(Sender).height;
//  s3.Left:=mx-(s1.width div 2);
//  s3.top:=my-(s1.height div 2);

//  s4.Left:=mx-(s1.width div 2);
//  s4.top:=my-(s1.height div 2);

  Screen.Cursor:=crDefault;

  clicked_on_component:=false;
//  DesignFrm.Canvas.Pen.Mode:=pmNot;
//  DesignFrm.Canvas.RoundRect( mx, my, (mx)+TPanel(Sender).width,(my)+TPanel(Sender).height,0, 0);
  DesignFrm.Refresh;
  iobject.Current:=StrToInt(tek.hint);

If GetProp(pTop)<>-1 then IObject.iObject[IObject.current].Properties[GetProp(pTop)].Value:=IntToStr(Views[IObject.Current].Top);
If GetProp(pLeft)<>-1 then IObject.iObject[IObject.current].Properties[GetProp(pLeft)].Value:=IntToStr(Views[IObject.Current].Left);
If GetProp(pWidth)<>-1 then IObject.iObject[IObject.current].Properties[GetProp(pWidth)].Value:=IntToStr(Views[IObject.Current].Width);
If GetProp(pHeight)<>-1 then IObject.iObject[IObject.current].Properties[GetProp(pHeight)].Value:=IntToStr(Views[IObject.Current].Height);
// Views[IObject.Current].Width:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pWidth)].Value);
// Views[IObject.Current].Height:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pHeight)].Value);


  ObjInspector.refresh;


// Code for apply changed params of component

end;
procedure TDesignFrm.ViewsMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
//
  DesignFrm.Canvas.Pen.Mode:=pmXor;
  DesignFrm.Canvas.Brush.Color := DesignFrm.Color;
  if clicked_on_component=true then
  begin
//   tek.Visible:=false;
   DesignFrm.Canvas.DrawFocusRect(TRect(Rect( mx, my, (mx)+TPanel(Sender).width,(my)+TPanel(Sender).height)));

   Screen.Cursor:=crDrag;

   mx_old:=mx;
   my_old:=my;
   if mshift then
   Begin
     mx:=(x-tmp_x);
     my:=(y-tmp_y);
   End Else
   Begin
     mx:=((x-tmp_x)div cellsize)*cellsize;
     my:=((y-tmp_y)div cellsize)*cellsize;
   End;
   DesignFrm.Canvas.DrawFocusRect(TRect(Rect( mx, my, (mx)+TPanel(Sender).width,(my)+TPanel(Sender).height)));
  end;
end;

procedure TDesignFrm.SizeMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin
//
  TPanel(Sender).Color:=clRed;

  sizex:=Tek.Left;
  sizey:=Tek.Top;
  tmpx:=Tek.Width;
  tmpy:=Tek.Height;
   {
  case StrToInt(TPanel(Sender).hint) of
  1:
    Begin
    End;
  2:
    Begin
    End;
  3:
    Begin
    End;
  4:
    Begin
    End;
  end;}
end;
procedure TDesignFrm.SizeMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin
//
  TPanel(Sender).Color:=clBlack;
  case StrToInt(TPanel(Sender).hint) of
  1:
    Begin
    End;
  2:
    Begin
    End;
  3:
    Begin
      Tek.Left:={sizex+}sizex;
      Tek.Width:={sizex+}tmpx;
      Tek.Height:={sizey+}tmpy;
    End;
  4:
    Begin
      Tek.Width:={sizex+}tmpx;
      Tek.Height:={sizey+}tmpy;
    End;
  end;

    ViewsMouseDown(Tek,Button,Shift,X,Y);
    ViewsMouseUp(Tek,Button,Shift,X,Y);

end;
procedure TDesignFrm.SizeMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
//
  If TPanel(Sender).Color = clRed then
  Begin
    DesignFrm.Canvas.Pen.Mode:=pmXor;
    DesignFrm.Canvas.Brush.Color := DesignFrm.Color;
    case StrToInt(TPanel(Sender).hint) of
    1:
      Begin
      End;
    2:
      Begin
      End;
    3:
      Begin
       DesignFrm.Canvas.DrawFocusRect(TRect(Rect( sizex, sizey, sizex+tmpx, sizey+tmpy)));

//       tmpy:=((Tek.Height+y)div cellsize)*cellsize;
//       sizex:=((Tek.left+x)div cellsize)*cellsize;
       If mshift then
       Begin
         tmpy:=(Tek.Height+y);
         sizex:=(Tek.left+x);
       End Else
       Begin
         tmpy:=((Tek.Height+y) div cellsize)*cellsize;
         sizex:=((Tek.left+x) div cellsize)*cellsize;
       End;

         tmpx:=(Tek.Width-x);

       DesignFrm.Canvas.DrawFocusRect(TRect(Rect( sizex, sizey, sizex+tmpx, sizey+tmpy)));
      End;
    4:
      Begin
       DesignFrm.Canvas.DrawFocusRect(TRect(Rect( sizex, sizey, sizex+tmpx, sizey+tmpy)));

       If mshift then
       Begin
         tmpx:=(Tek.Width+x);
         tmpy:=(Tek.Height+y);
       End Else
       Begin
         tmpx:=((Tek.Width+x)div cellsize)*cellsize;
         tmpy:=((Tek.Height+y)div cellsize)*cellsize;
       End;
       //  
//       rectangle(GetDC(Win.Handle), x_, y_, x_+w_,y_+h_); //
       DesignFrm.Canvas.DrawFocusRect(TRect(Rect( sizex, sizey, sizex+tmpx, sizey+tmpy)));
      End;
    end;
  End;
end;


procedure TDesignFrm.FormCreate(Sender: TObject);
begin
//===================== [Form top coord]
 DesignFrm.Top:=115;
//===================== [Form top coord]
 WinBorderColor:=clBlue;
 DesignFrm.color:=clSilver;
 cellsize:=8;
 form_click:=false;
 mshift:=false;

  INIFile:=TIniFile.Create(ExtractFilePath(Application.exename)+'Components.ini');
  ObjectInspector.IObject.Count:=INIFile.ReadInteger('COMPONENTS','Count',0);
  ObjectInspector.IObject.Current:=INIFile.ReadInteger('COMPONENTS','Current',1);

  For i:=1 to ObjectInspector.IObject.Count do
  begin
    ObjectInspector.IObject.iObject[i].iname:=INIFile.ReadString('COMPONENT'+inttostr(i),'Name','NoName');
    ObjectInspector.IObject.iObject[i].itype:=INIFile.ReadString('COMPONENT'+inttostr(i),'Type','Unknow');
    ObjectInspector.IObject.iObject[i].PCount:=INIFile.ReadInteger('COMPONENT'+inttostr(i),'PropertiesCount',0);
    Views[i]:=TPanel.Create(self);

    Views[i].OnMouseDown:=ViewsMouseDown;
    Views[i].OnMouseUp:=ViewsMouseUp;
    Views[i].OnMouseMove:=ViewsMouseMove;
    If ObjectInspector.IObject.iObject[i].itype = 'TButton' then
    begin
      Views[i].Ctl3D:=true;
      Views[i].Color:=clBtnFace;
    end else
    If ObjectInspector.IObject.iObject[i].itype = 'TLabel' then
    begin
      Views[i].Ctl3D:=false;
      Views[i].Color:=clBtnFace;
      Views[i].Width:=100;
      Views[i].Height:=12;
      Views[i].BorderStyle:=bsNone;
      Views[i].BevelInner:=bvNone;
      Views[i].BevelOuter:=bvNone;
    end;
    For j:=1 to ObjectInspector.IObject.iObject[i].PCount do
    begin
      ObjectInspector.IObject.iObject[i].Properties[j].iname:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Name','NoName');
      ObjectInspector.IObject.iObject[i].Properties[j].itype.iType:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Type','Unknow');
      ObjectInspector.IObject.iObject[i].Properties[j].Value:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Value','Undefined');
      ObjectInspector.IObject.iObject[i].Properties[j].itype.Count:=INIFile.ReadInteger('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'SubvalueCount',0);
      if IObject.iObject[i].Properties[j].itype.Count > 0 then
      begin
        For k:=1 to ObjectInspector.IObject.iObject[i].Properties[j].itype.Count do
        begin
          ObjectInspector.IObject.iObject[i].Properties[j].itype.Values[k]:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Subvalue'+inttostr(k),'Undefined');
        end;
      end;

//   ,  ...
      If ObjectInspector.IObject.iObject[i].itype = 'TButton' then
      begin
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pLeft then
        begin
          Views[i].left:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end else
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pTop then
        begin
          Views[i].Top:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end else
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pWidth then
        begin
          Views[i].Width:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end else
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pHeight then
        begin
          Views[i].Height:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end;
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pText then
        begin
          Views[i].Caption:=ObjectInspector.IObject.iObject[i].Properties[j].Value;
        end;
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pColor then
        begin
          if ObjectInspector.IObject.iObject[i].Properties[j].Value = 'clLight' then
          begin
            Views[i].color:=clSilver;
          end;
        end;
      end;
//   ,  ...
      If ObjectInspector.IObject.iObject[i].itype = 'TLabel' then
      begin
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pLeft then
        begin
          Views[i].left:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end else
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pTop then
        begin
          Views[i].Top:=StrToInt(ObjectInspector.IObject.iObject[i].Properties[j].Value);
        end else
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pText then
        begin
          Views[i].Caption:=ObjectInspector.IObject.iObject[i].Properties[j].Value;
        end;
        If ObjectInspector.IObject.iObject[i].Properties[j].iname = pColor then
        begin
          if ObjectInspector.IObject.iObject[i].Properties[j].Value = 'clLight' then
          begin
            Views[i].Font.color:=clSilver;
          end;
          if ObjectInspector.IObject.iObject[i].Properties[j].Value = 'clBlack' then
          begin
            Views[i].Font.color:=clBlack;
          end;
        end;
      end;
    end;
    ObjectInspector.IObject.iObject[i].ECount:=INIFile.ReadInteger('COMPONENT'+inttostr(i),'EventsCount',0);
    For j:=1 to ObjectInspector.IObject.iObject[i].ECount do
    begin
      ObjectInspector.IObject.iObject[i].Events[j].iname:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'EVENT'+inttostr(j),'Name','NoName');
      ObjectInspector.IObject.iObject[i].Events[j].Value:=IObject.iObject[i].iname+'_'+INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'EVENT'+inttostr(j),'Value','Undefined');
    end;
    Views[i].Visible:=true;
    Views[i].hint:=inttostr(i);
    DesignFrm.InsertControl(Views[i]);
  end;
  INIFile.Free;


end;

procedure TDesignFrm.FormPaint(Sender: TObject);
const
	dotx = 8;
	doty = 8;
	offx = 2;
	offy = 2;
var
	br,br_old: TBrush;
//        tmp:TBitmap;
begin
//        cnvs:=TCanvas.Create;
//        tmp:=TBitmap.Create;

        bordersize:=1;
	br := TBrush.Create;
	br_old := TBrush.Create;
	br_old.Assign(Canvas.Brush);
	br.Bitmap := TBitmap.Create;
	with br.Bitmap do begin
		Width := dotx;
		Height := doty;
		Canvas.Brush.Color := clSilver;
		Canvas.FillRect(Rect(0,0,dotx,doty));
                Canvas.Pixels[(bordersize-1) mod dotx,(BasePict.Height-1) mod doty] := clBtnText;
		self.Canvas.Brush.Assign(br);
		self.Canvas.FillRect(TRect(Rect(bordersize,BasePict.Height,DesignFrm.Width-bordersize,DesignFrm.Height-bordersize)));
		Free;
	end;
	Canvas.Brush.Assign(br_old);
	br_old.Free;
	br.Free;

//=====[ ]
 DesignFrm.Canvas.Pen.Mode:=pmcopy;
 DesignFrm.Canvas.MoveTo(0,0);
 DesignFrm.Canvas.LineTo(0,DesignFrm.Height-1);
 DesignFrm.Canvas.LineTo(DesignFrm.Width-1,DesignFrm.Height-1);
 DesignFrm.Canvas.LineTo(DesignFrm.Width-1,0);

 DesignFrm.Canvas.MoveTo(4,0);
 DesignFrm.Canvas.LineTo(4,DesignFrm.Height-5);
 DesignFrm.Canvas.LineTo(DesignFrm.Width-5,DesignFrm.Height-5);
 DesignFrm.Canvas.LineTo(DesignFrm.Width-5,5);

 DesignFrm.Canvas.Brush.Color := WinBorderColor;
 DesignFrm.Canvas.Brush.Style := bsSolid;
 DesignFrm.Canvas.FillRect(Rect(1, 1, 4, DesignFrm.Height-1));
 DesignFrm.Canvas.FillRect(Rect(1,DesignFrm.Height-4,DesignFrm.Width-1,DesignFrm.Height-1));
 DesignFrm.Canvas.FillRect(Rect(DesignFrm.Width-1, 1, DesignFrm.Width-4, DesignFrm.Height-1));

// For i:=0 to Round(DesignFrm.Width / BasePict.Width) do
// begin
//   BitBlt(DesignFrm.Canvas.Handle,i*BasePict.Width,0,BasePict.Width,BasePict.Height,BasePict.Canvas.Handle,0,0,SRCCOPY);
// end;
//   BitBlt(DesignFrm.Canvas.Handle,0,0,LeftPict.Width,LeftPict.Height,LeftPict.Canvas.Handle,0,0,SRCCOPY);
//   BitBlt(DesignFrm.Canvas.Handle,DesignFrm.Width-OperPict.Width,0,OperPict.Width,OperPict.Height,OperPict.Canvas.Handle,0,0,SRCCOPY);
 For i:=0 to Round(DesignFrm.Width / BasePict.Width) do
 begin
   BitBlt(DesignFrm.Canvas.Handle,i*BasePict.Width,0,BasePict.Width,BasePict.Height,BasePict.Canvas.Handle,0,0,SRCCOPY);
 end;
   BitBlt(DesignFrm.Canvas.Handle,0,0,LeftPict.Width,LeftPict.Height,LeftPict.Canvas.Handle,0,0,SRCCOPY);
   BitBlt(DesignFrm.Canvas.Handle,DesignFrm.Width-OperPict.Width,0,OperPict.Width,OperPict.Height,OperPict.Canvas.Handle,0,0,SRCCOPY);
//=====[ ]
//   DesignFrm.Canvas:=tmp.Canvas;
//   DesignFrm.Canvas.BrushCopy(TRect(Rect(0,0,DesignFrm.Width,DesignFrm.Height)),tmp, TRect(Rect(0,0,DesignFrm.Width,DesignFrm.Height)), clBlack);
//   DesignFrm.Canvas.CopyRect(TRect(Rect(0,0,DesignFrm.Width,DesignFrm.Height)),tmp.Canvas,TRect(Rect(0,0,DesignFrm.Width,DesignFrm.Height)));

//   BitBlt(DesignFrm.Canvas.Handle,0,0,DesignFrm.Width,DesignFrm.Height,tmp.Canvas.Handle,0,0,SRCCOPY);
//   Tmp.Free;
end;

procedure TDesignFrm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if CurrC<>0 then
 Begin
    ObjectInspector.IObject.Count:=ObjectInspector.IObject.Count+1;
    Views[ObjectInspector.IObject.Count]:=TPanel.Create(self);
    Views[ObjectInspector.IObject.Count].OnMouseDown:=ViewsMouseDown;
    Views[ObjectInspector.IObject.Count].OnMouseUp:=ViewsMouseUp;
    Views[ObjectInspector.IObject.Count].OnMouseMove:=ViewsMouseMove;
    Views[ObjectInspector.IObject.Count].left:=(x div cellsize)*cellsize;
    Views[ObjectInspector.IObject.Count].top:=(y div cellsize)*cellsize;
    Views[ObjectInspector.IObject.Count].hint:=IntToStr(ObjectInspector.IObject.Count);
    If CurrC=2 then  // Button
    begin
      Views[ObjectInspector.IObject.Count].Ctl3D:=true;
      Views[ObjectInspector.IObject.Count].Color:=clSilver;
      Views[ObjectInspector.IObject.Count].Width:=100;
      Views[ObjectInspector.IObject.Count].Height:=50;
      Views[ObjectInspector.IObject.Count].Caption:='Button';

      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].iName:='Button';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].iType:='TButton';

      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].PCount:=8;
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].iname:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].value:='Button';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].iname:='Font';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].value:='Small';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].itype.itype:='Font';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].iname:='Color';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].value:='clLight';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].itype.itype:='Color';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].iname:='Left';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].value:='0';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].iname:='Top';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].value:='0';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[6].iname:='Width';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[6].value:='100';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[6].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[7].iname:='Height';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[7].value:='50';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[7].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].iname:='Flat';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].value:='false';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].itype.itype:='Combo';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].itype.count:=2;
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].itype.values[1]:='true';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[8].itype.values[2]:='false';

      Editor.RichEdit1.Lines.Insert(DEditor.Find('startwd'),DEditor.TAB+'button'+DEditor.TAB+';['+Views[ObjectInspector.IObject.Count].hint+']');
    end else
    If CurrC=1 then  // Label
    begin
      Views[ObjectInspector.IObject.Count].Ctl3D:=false;
      Views[ObjectInspector.IObject.Count].Color:=clBtnFace;
      Views[ObjectInspector.IObject.Count].Width:=100;
      Views[ObjectInspector.IObject.Count].Height:=12;
      Views[ObjectInspector.IObject.Count].BorderStyle:=bsNone;
      Views[ObjectInspector.IObject.Count].BevelInner:=bvNone;
      Views[ObjectInspector.IObject.Count].BevelOuter:=bvNone;
      Views[ObjectInspector.IObject.Count].Caption:='Label';

      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].iName:='Label';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].iType:='TLabel';

      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].PCount:=5;
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].iname:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].value:='Label';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].iname:='Font';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].value:='Small';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[2].itype.itype:='Font';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].iname:='Color';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].value:='clLight';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[3].itype.itype:='Color';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].iname:='Left';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].value:='0';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[4].itype.itype:='Text';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].iname:='Top';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].value:='0';
      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[5].itype.itype:='Text';
//      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].iname:='Text';
//      ObjectInspector.IObject.iObject[ObjectInspector.IObject.Count].Properties[1].iname:='Label';
      Editor.RichEdit1.Lines.Insert(DEditor.Find('startwd'),DEditor.TAB+'label'+DEditor.TAB+IntToStr(Views[ObjectInspector.IObject.Count].left)+','+IntToStr(Views[ObjectInspector.IObject.Count].top)+',"'+Views[ObjectInspector.IObject.Count].caption+'"'+DEditor.TAB+';['+Views[ObjectInspector.IObject.Count].hint+']');
    end;

    Views[ObjectInspector.IObject.Count].Visible:=true;

    ObjectInspector.IObject.Current:=StrToInt(Views[ObjectInspector.IObject.Count].hint);

    DesignFrm.InsertControl(Views[ObjectInspector.IObject.Count]);
    CurrC:=0;
    MainForm.MainWindow.SpeedButton11.Down:=true;

//  
      tek:=Views[ObjectInspector.IObject.Current];
      ViewsMouseDown(Tek,TMouseButton(nil),Shift,0,0);
      ViewsMouseUp(Tek,TMouseButton(nil),Shift,0,0);

//    for i:=1 to ObjectInspector.IObject.Count do
//    Begin
//      Views[i].hint:=inttostr(i);
//    End;


    ObjInspector.refresh;
 End Else
 Begin
   form_click:=true;
   tmpx:=x;
   tmpy:=y;
 End;
end;

procedure TDesignFrm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  form_click:=false;
end;


procedure TDesignFrm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if form_click then
  Begin
//     DesignFrm.left:=(x-tmp_x){+DesignFrm.left};
//     DesignFrm.top:=(y-tmp_y){+DesignFrm.top};
     DesignFrm.left:=DesignFrm.left+x-tmpx;
     DesignFrm.top:=DesignFrm.top+y-tmpy;
  End;
end;

procedure TDesignFrm.FormKeyPress(Sender: TObject; var Key: Char);
begin
//  If GetFocus=Tek.Handle then
//  Begin
//     ShowMessage(IntToStr((Ord(VkKeyScan(key)))));
//  End;
end;

procedure TDesignFrm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
// Delete - 190
// Ctrl+C - 323
// Ctrl+V - 342
// Shift  - 592
//     ShowMessage(IntToStr((Ord(VkKeyScan(char(key))))));

// if ssShift in Shift  then
// Begin
//  mshift:= not (ssShift in Shift);
//  showmessage('up');
// End Else
// Begin
  if Ord(VkKeyScan(char(key)))=190 then
  Begin
    for i:=ObjectInspector.IObject.Current to ObjectInspector.IObject.Count-1 do
    Begin
      ObjectInspector.IObject.iObject[i]:=ObjectInspector.IObject.iObject[i+1];
    End;

      ObjectInspector.IObject.Count:=ObjectInspector.IObject.Count-1;
      ObjectInspector.IObject.Current:=ObjectInspector.IObject.Count+1;
//      Tek.Free;
      tek.free;
      tek:=Views[ObjectInspector.IObject.Current];

      for i:=1 to ObjectInspector.IObject.Count do
      Begin
        Views[i].hint:=inttostr(i);
      End;

      s1.visible:=false;
      s2.visible:=false;
      s3.visible:=false;
      s4.visible:=false;
//  
      ViewsMouseDown(Tek,TMouseButton(nil),Shift,0,0);
      ViewsMouseUp(Tek,TMouseButton(nil),Shift,0,0);

      ObjInspector.OnPaint(self);
  End Else
  If Ord(VkKeyScan(char(key)))=592 then
  Begin
    mshift:=false;
  End;
//  End;
end;

procedure TDesignFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  mshift:= ssShift in Shift;
//  showmessage('down');
  If Ord(VkKeyScan(char(key)))=592 then
  Begin
    mshift:=true;
  End;
end;
end.
