unit ObjectInspector;

interface
            
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, IniFiles, ExtCtrls, Buttons;

type
  TObjInspector = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    StringGrid1: TStringGrid;
    ScrollBox2: TScrollBox;
    StringGrid2: TStringGrid;
    Panel1: TPanel;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Apply: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormPaint(Sender: TObject);
    procedure MyOnChange(Sender: TObject;  var Key: Char);
    procedure MyEnter(Sender: TObject);
    procedure TabSheet1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure StringGrid2DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ApplyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
Type
     TiPropType=record
       iType:String;
       Values:array[1..100] of string;
       Count:Integer;
     end;
     TiProperty=record
       iName:string;
       iType:TiPropType;
       Value:String;
     end;
     TiEvents=record
       iName:string;
       Value:String;
     end;
     TiObject=record
       iName:string;
       iType:String;
       Properties:array[1..100] of TiProperty;
       PCount:integer;
       Events:array[1..100] of TiEvents;
       ECount:integer;
     end;
     TObjectInspector=record
       Title:string;
       iObject:array [1..1000] of TiObject;
       Count:Integer;
       Current:integer;
     end;
Const CountColors=16;
      ColorTable:array[1..CountColors] of string=('clWhite',
                                                  'clBlack',
                                                  'clMaroon',
                                                  'clBlue',
                                                  'clRed',
                                                  'clGreen',
                                                  'clYellow',
                                                  'clSilver',
                                                  'clGray',
                                                  'clCream',
                                                  'clSkyBlue',
                                                  'clMoneyGreen',
                                                  'clAqua',
                                                  'clTeal',
                                                  'clLime',
                                                  'clNavy');

   pText   =  'Text';
   pFont   =  'Font';
   pColor  =  'Color';
   pLeft   =  'Left';
   pTop    =  'Top';
   pWidth  =  'Width';
   pHeight =  'Height';
   pFlat   =  'Flat';

var
  ObjInspector: TObjInspector;
  Edit, Edit2:TEdit;
  Combo:TComboBox;
  Btn:TButton;

  IObject:TObjectInspector;
  Tek:integer;
  IniFile:TIniFile;
//   ))    ;)
  Shift:TShiftState;
{  i,j,k:integer;}
  Function GetProp(s:string):integer;
implementation
Uses DesignForm;
{$R *.DFM}
//procedure TObjInspector.MyKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
//begin
//end;

Function GetProp(s:string):integer;
Var i:integer;
Begin
  for i:=1 to IObject.iObject[IObject.current].PCount do
  Begin
    if IObject.iObject[IObject.current].Properties[i].iName=s then
    Begin
      GetProp:=i;
      Break;
    End;
      GetProp:=-1;
  End;
End;
procedure TObjInspector.MyOnChange(Sender: TObject;  var Key: Char);
begin
  If pagecontrol1.ActivePage=TabSheet1 then
  begin
//  SHowmessage('!!');
  if (Sender is TEdit) then
  begin
    IObject.iObject[IObject.current].Properties[tek+1].Value:=TEdit(Sender).text;
  end else
  if (Sender is TComboBox) then
  begin
    IObject.iObject[IObject.current].Properties[tek+1].Value:=TComboBox(Sender).text;
  end;
  end else
  If pagecontrol1.ActivePage=TabSheet2 then
  begin
//  SHowmessage('!!');
  if (Sender is TEdit) then
  begin
    IObject.iObject[IObject.current].Events[tek+1].Value:=TEdit(Sender).text;
  end else
  if (Sender is TComboBox) then
  begin
    IObject.iObject[IObject.current].Events[tek+1].Value:=TComboBox(Sender).text;
  end;
  end;
if key=#13 then
begin
 ApplyClick(self);
end;
//
end;
procedure TObjInspector.MyEnter(Sender: TObject);
Var i,j:integer;
begin
  If pagecontrol1.ActivePage=TabSheet1 then
  begin
//  SHowmessage('!!');
  if (Sender is TEdit) then
  begin
    IObject.iObject[IObject.current].Properties[tek+1].Value:=TEdit(Sender).text;
  end else
  if (Sender is TComboBox) then
  begin
    IObject.iObject[IObject.current].Properties[tek+1].Value:=TComboBox(Sender).text;
  end;
//
  end else
  If pagecontrol1.ActivePage=TabSheet2 then
  begin
//  SHowmessage('!!');
  if (Sender is TEdit) then
  begin
    IObject.iObject[IObject.current].Events[tek+1].Value:=TEdit(Sender).text;
  end;
  end;
   ComboBox1.text:=IObject.iObject[IObject.current].iName+':'+IObject.iObject[IObject.current].iType;
   for j:=1 to IObject.iObject[IObject.current].PCount do
   begin
//     StringGrid1.Cells[0,j-1]:=IObject.iObject[i].Properties[j].iname;
     StringGrid1.Cells[1,j-1]:=IObject.iObject[IObject.current].Properties[j].Value;
//     if j>=IObject.iObject[i].PCount-1 then
//     begin
//     StringGrid1.RowCount:=StringGrid1.RowCount+1;
//     StringGrid1.RowHeights[j-2]:=20;
//     end;
//     StringGrid1.RowHeights[j-1]:=20;
//     Inc(StringGrid1.RowCount,1);
   end;
   for j:=1 to IObject.iObject[IObject.current].ECount do
   begin
//     StringGrid1.Cells[0,j-1]:=IObject.iObject[i].Properties[j].iname;
     StringGrid2.Cells[1,j-1]:=IObject.iObject[IObject.current].Events[j].Value;
//     if j>=IObject.iObject[i].PCount-1 then
//     begin
//     StringGrid1.RowCount:=StringGrid1.RowCount+1;
//     StringGrid1.RowHeights[j-2]:=20;
//     end;
//     StringGrid1.RowHeights[j-1]:=20;
//     Inc(StringGrid1.RowCount,1);
   end;

end;
procedure TObjInspector.FormCreate(Sender: TObject);
begin
  ObjInspector.Left:=0;
  
  ComboBox1.ItemIndex:=0;
  IObject.Current:=1;

  Edit:=TEdit.Create(StringGrid1);
  Edit.Parent:=StringGrid1;
  Edit.Ctl3D:=true;
  Edit.OnKeyPress:=ObjInspector.MyOnChange;
//  Edit.OnEnter:=ObjInspector.MyEnter;
  Edit.OnExit:=ObjInspector.MyEnter;
  Edit.OnClick:=ObjInspector.MyEnter;
  Edit.Visible:=false;

  Edit2:=TEdit.Create(StringGrid2);
  Edit2.Parent:=StringGrid2;
  Edit2.Ctl3D:=true;
  Edit2.OnKeyPress:=ObjInspector.MyOnChange;
//  Edit.OnEnter:=ObjInspector.MyEnter;
  Edit2.OnExit:=ObjInspector.MyEnter;
  Edit2.OnClick:=ObjInspector.MyEnter;
  Edit2.Visible:=false;

  Btn:=TButton.Create(StringGrid1);
  Btn.Parent:=StringGrid1;
  Btn.Caption:='...';
  Btn.Visible:=false;
  Combo:=TCombobox.Create(StringGrid1);
//  Combo.Parent:=StringGrid1;
  Combo.Parent:=TabSheet1;
  Combo.OnKeyPress:=ObjInspector.MyOnChange;
//  Combo.OnEnter:=ObjInspector.MyEnter;
  Combo.OnExit:=ObjInspector.MyEnter;
  Combo.OnClick:=ObjInspector.MyEnter;
  Combo.Visible:=false;
//  Edit:=TEdit.Create(StringGrid1);
//  Edit.Parent:=StringGrid1;
//  Edit.Ctl3D:=true;
//  Edit.OnChange:=ObjInspector.OnChange;
//  Edit.Visible:=false;
//  Btn:=TButton.Create(StringGrid1);
//  Btn.Parent:=StringGrid1;
//  Btn.Caption:='...';
//  Btn.Visible:=false;
//  Combo:=TCombobox.Create(StringGrid1);
//  Combo.Parent:=StringGrid1;
//  Combo.OnChange:=ObjInspector.OnChange;
//  Combo.Visible:=false;

  StringGrid1.ColWidths[0]:=ScrollBox1.Width div 2;
  StringGrid1.ColWidths[1]:=ScrollBox1.Width div 2;

  StringGrid2.ColWidths[0]:=ScrollBox2.Width div 2;
  StringGrid2.ColWidths[1]:=ScrollBox2.Width div 2;

  IObject.Title:='Object Inspector';
{
  INIFile:=TIniFile.Create(ExtractFilePath(Application.exename)+'Components.ini');
  IObject.Count:=INIFile.ReadInteger('COMPONENTS','Count',0);
  IObject.Current:=INIFile.ReadInteger('COMPONENTS','Current',1);

  For i:=1 to IObject.Count do
  begin
    IObject.iObject[i].iname:=INIFile.ReadString('COMPONENT'+inttostr(i),'Name','NoName');
    IObject.iObject[i].itype:=INIFile.ReadString('COMPONENT'+inttostr(i),'Type','Unknow');
    IObject.iObject[i].PCount:=INIFile.ReadInteger('COMPONENT'+inttostr(i),'PropertiesCount',0);
    For j:=1 to IObject.iObject[i].PCount do
    begin
      IObject.iObject[i].Properties[j].iname:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Name','NoName');
      IObject.iObject[i].Properties[j].itype.iType:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Type','Unknow');
      IObject.iObject[i].Properties[j].Value:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Value','Undefined');
      IObject.iObject[i].Properties[j].itype.Count:=INIFile.ReadInteger('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'SubvalueCount',0);
      if IObject.iObject[i].Properties[j].itype.Count > 0 then
      begin
        For k:=1 to IObject.iObject[i].Properties[j].itype.Count do
        begin
          IObject.iObject[i].Properties[j].itype.Values[k]:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'PROPERTLY'+inttostr(j),'Subvalue'+inttostr(k),'Undefined');
        end;
      end;
    end;
    IObject.iObject[i].ECount:=INIFile.ReadInteger('COMPONENT'+inttostr(i),'EventsCount',0);
    For j:=1 to IObject.iObject[i].ECount do
    begin
      IObject.iObject[i].Events[j].iname:=INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'EVENT'+inttostr(j),'Name','NoName');
      IObject.iObject[i].Events[j].Value:=IObject.iObject[i].iname+'_'+INIFile.ReadString('COMPONENT'+inttostr(i)+'_'+'EVENT'+inttostr(j),'Value','Undefined');
    end;
  end;
  INIFile.Free;}
  {
  //=============================================================[   ]
  IObject.iObject[IObject.Count].PCount:=1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:=' 1';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Font';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='Small';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Color';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='clWhite';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' X';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='10';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' Y';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='10';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='50';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='100';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='Flat';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Combo';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='True';

  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.Count:=2;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.Values[1]:='True';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.Values[2]:='False';
  //=============================================================[   ]

  //=============================================================[   ]
  IObject.iObject[IObject.Count].ECount:=1;
  IObject.iObject[IObject.Count].Events[IObject.iObject[IObject.Count].ECount].iname:='OnClick';
  IObject.iObject[IObject.Count].Events[IObject.iObject[IObject.Count].ECount].Value:='TButton1_OnClick_handler';

  IObject.iObject[IObject.Count].ECount:=IObject.iObject[IObject.Count].ECount+1;
  IObject.iObject[IObject.Count].Events[IObject.iObject[IObject.Count].ECount].iname:='OnDBClick';
  IObject.iObject[IObject.Count].Events[IObject.iObject[IObject.Count].ECount].Value:='TButton1_OnDBClick_handler';
  //=============================================================[   ]

//:)

  IObject.Count:=IObject.Count+1;
//  IObject.Current:=IObject.Current+1;
  IObject.iObject[IObject.Count].iname:='Label1';
  IObject.iObject[IObject.Count].itype:='TLabel';
  //=============================================================
  IObject.iObject[IObject.Count].PCount:=1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:=' 1';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Font';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='BIG';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Color';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='clBlack';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' X';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='1';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' Y';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='1';


  IObject.Count:=IObject.Count+1;
//  IObject.Current:=IObject.Current+1;
  IObject.iObject[IObject.Count].iname:='Label2';
  IObject.iObject[IObject.Count].itype:='TLabel';
  //=============================================================
  IObject.iObject[IObject.Count].PCount:=1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:=' 2';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Font';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='Small';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Color';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='clBlue';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' X';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='20';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' Y';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='20';

  IObject.Count:=IObject.Count+1;
//  IObject.Current:=IObject.Current+1;
  IObject.iObject[IObject.Count].iname:='Image1';
  IObject.iObject[IObject.Count].itype:='TImage';
  //=============================================================
  IObject.iObject[IObject.Count].PCount:=1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:='';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Font';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='C:\picture.bmp';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' X';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='20';

  //=============================================================
  IObject.iObject[IObject.Count].PCount:=IObject.iObject[IObject.Count].PCount+1;
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].iname:=' Y';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].itype.iType:='Text';
  IObject.iObject[IObject.Count].Properties[IObject.iObject[IObject.Count].PCount].Value:='20';
 }
  ObjInspector.Caption:=IObject.Title;

end;

procedure TObjInspector.StringGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
Var i:integer;
begin

 if ((StringGrid1.Col=Col) and (StringGrid1.Row=Row)) then
 begin
 Tek:=row;

 if IObject.iObject[IObject.current].Properties[row+1].itype.iType='Color' then
 begin
   Combo.Left:={TabSheet1.Left+}Rect.Left+2;
   Combo.Top:={TabSheet1.Top+}Rect.Top+2;
   Combo.Width:=(Rect.right div 2)-5;
   Combo.Height:=15;
   Combo.text:=IObject.iObject[IObject.current].Properties[tek+1].Value;//IObject.iObject[IObject.current].Properties[row+1].Value;
   Combo.Visible:=true;
//  Combo.AutoDropDown:=true;
//  Combo.AutoComplete:=true;
//  Combo.Ctl3D:=true;
//  Combo.DropDownCount:=CountColors;
  Combo.Items.Clear;
//  Combo.DroppedDown:=true;
  For i:=1 to CountColors do
  begin
     Combo.Items.Add(ColorTable[i]);
  end;

   Edit.Visible:=false;
   Btn.Visible:=false;

   Combo.SetFocus;
//   StringGrid1.Cells[col,row]:=IObject.iObject[IObject.current].Properties[tek+1].Value;//   StringGrid1.Canvas.Pen.Color:=clBtnFace;
 end else
 if IObject.iObject[IObject.current].Properties[row+1].itype.iType='Combo' then
 begin
   Combo.Left:={TabSheet1.Left+}Rect.Left+2;
   Combo.Top:={TabSheet1.Top+}Rect.Top+2;
   Combo.Width:=(Rect.right div 2)-5;
   Combo.Height:=20;
   Combo.text:=IObject.iObject[IObject.current].Properties[tek+1].Value;//IObject.iObject[IObject.current].Properties[row+1].Value;
   Combo.Visible:=true;
//  Combo.AutoDropDown:=true;
//  Combo.AutoComplete:=true;
//  Combo.Ctl3D:=true;
//  Combo.DropDownCount:=CountColors;
  Combo.Items.Clear;
//  Combo.DroppedDown:=true;
  For i:=1 to IObject.iObject[IObject.Current].Properties[tek+1].itype.Count do
  begin
     Combo.Items.Add(IObject.iObject[IObject.Current].Properties[tek+1].itype.Values[i]);
  end;

   Edit.Visible:=false;
   Btn.Visible:=false;

   Combo.SetFocus;
//   StringGrid1.Cells[col,row]:=IObject.iObject[IObject.current].Properties[tek+1].Value;//   StringGrid1.Canvas.Pen.Color:=clBtnFace;
 end else
 if IObject.iObject[IObject.current].Properties[row+1].itype.iType='Text' then
 begin
   Edit.Left:=Rect.Left;
   Edit.Top:=Rect.Top;
   Edit.Width:=(Rect.right div 2)-5;
   Edit.Height:=20;
   Edit.Parent:=StringGrid1;
   Edit.Text:=IObject.iObject[IObject.current].Properties[tek+1].Value;//IObject.iObject[IObject.current].Properties[row+1].Value;
   Edit.Visible:=true;
   Btn.Visible:=false;
   Combo.Visible:=false;
//   Edit.SetFocus;
//   StringGrid1.Cells[col,row]:=IObject.iObject[IObject.current].Properties[tek+1].Value;//   StringGrid1.Canvas.Pen.Color:=clBtnFace;
 end else
 if IObject.iObject[IObject.current].Properties[row+1].itype.iType='Font' then
 begin
   Btn.Left:=(rect.right)-25;
   Btn.Top:=Rect.Top;
   Btn.Width:=20;
   Btn.Height:=20;
   Btn.Parent:=StringGrid1;

   Edit.Left:=Rect.Left;
   Edit.Top:=Rect.Top;
   Edit.Width:=((Rect.right div 2)-5)-Btn.Height;
   Edit.Height:=20;
   Edit.Parent:=StringGrid1;
   Edit.Text:=IObject.iObject[IObject.current].Properties[tek+1].Value;//IObject.iObject[IObject.current].Properties[row+1].Value;
   Edit.Visible:=true;

   Btn.Visible:=true;
   Combo.Visible:=false;
//   Edit.SetFocus;
//   StringGrid1.Cells[col,row]:=IObject.iObject[IObject.current].Properties[tek+1].Value;//   StringGrid1.Canvas.Pen.Color:=clBtnFace;
 end;

//   StringGrid1.Canvas.Pen.Color:=clBlue;
//   StringGrid1.Canvas.Brush.Color:=clWhite;
//   StringGrid1.Canvas.FillRect(Rect);

//   Edit.Left:=Rect.Left;
//   Edit.Top:=Rect.Top;
//   Edit.Width:=(Rect.right div 2)-5;
//   Edit.Height:=20;
//   Edit.Parent:=StringGrid1;
//   Edit.Text:=StringGrid1.Cells[1,row];
//   Edit.Visible:=true;

//   Btn.Left:=(rect.right)-25;
//   Btn.Top:=Rect.Top+2;
//   Btn.Width:=18;
//   Btn.Height:=16;
//   Btn.Parent:=StringGrid1;
//   Btn.Visible:=true;

//   Combo.Left:=Rect.Left;
//   Combo.Top:=Rect.Top;
//   Combo.Width:=(Rect.right div 2)-5;
//   Combo.Height:=20;
//   Combo.Visible:=true;

 end else
 begin
//   StringGrid1.Canvas.FillRect(Rect);
//   Edit.Visible:=false;
//   Combo.Visible:=false;
 end;
end;

procedure TObjInspector.FormPaint(Sender: TObject);
Var i,j:integer;
begin
 If IObject.Count>0 then
 Begin

 StringGrid1.RowCount:=1;
 StringGrid1.ColCount:=2;

 if IObject.iObject[IObject.Current].ECount=0 then
 begin
//   StringGrid2.RowCount:=0;
//   StringGrid2.ColCount:=0;
   StringGrid2.Visible:=false;
//   edit2.Visible:=false;
 end else
 begin
   StringGrid2.RowCount:=1;
   StringGrid2.ColCount:=2;
   StringGrid2.FixedCols:=1;
   StringGrid2.ColWidths[0]:=ScrollBox2.Width div 2;
   StringGrid2.ColWidths[1]:=ScrollBox2.Width div 2;
   StringGrid2.Visible:=true;
 end;
 ObjInspector.Caption:=IObject.Title;

 Combobox1.Enabled:=true;
 Combobox1.Items.Clear;
 For i:=1 to IObject.Count do
 begin
  ComboBox1.Items.Add(IObject.iObject[i].iName+':'+IObject.iObject[i].iType);
 end;
    ComboBox1.ItemIndex:=IObject.Current-1;
 // ComboBox1.text:=ComboBox1.Items.Strings[IObject.Current-1];

// for i:=1 to IObject.Count do
// begin
//   Showmessage(inttostr(IObject.iObject[i].PCount));
 if IObject.iObject[IObject.Current].PCount>0 then
 Begin
   StringGrid1.Visible:=true;
   StringGrid2.Visible:=true;
   for j:=1 to IObject.iObject[IObject.Current].PCount-1 do
   begin
//     if j>=IObject.iObject[i].PCount-1 then
//     begin
     StringGrid1.RowCount:=StringGrid1.RowCount+1;
     StringGrid1.RowHeights[StringGrid1.RowCount-2]:=20;
//      end;
     StringGrid1.RowHeights[StringGrid1.RowCount-1]:=20;
//     Inc(StringGrid1.RowCount,1);

//     Showmessage(inttostr(IObject.iObject[i].PCount));
     StringGrid1.Cells[0,j-1]:=IObject.iObject[IObject.Current].Properties[j].iname;
     StringGrid1.Cells[1,j-1]:=IObject.iObject[IObject.Current].Properties[j].Value;
   end;
     StringGrid1.Cells[0,j-1]:=IObject.iObject[IObject.Current].Properties[j].iname;
     StringGrid1.Cells[1,j-1]:=IObject.iObject[IObject.Current].Properties[j].Value;
 end;

 if IObject.iObject[IObject.Current].ECount>0 then
 Begin
   for j:=1 to IObject.iObject[IObject.Current].ECount-1 do
   begin
//     if j>=IObject.iObject[i].PCount-1 then
//     begin
     StringGrid2.RowCount:=StringGrid2.RowCount+1;
     StringGrid2.RowHeights[StringGrid2.RowCount-2]:=20;
//      end;
     StringGrid2.RowHeights[StringGrid2.RowCount-1]:=20;
//     Inc(StringGrid1.RowCount,1);

//     Showmessage(inttostr(IObject.iObject[i].PCount));
     StringGrid2.Cells[0,j-1]:=IObject.iObject[IObject.Current].Events[j].iname;
     StringGrid2.Cells[1,j-1]:=IObject.iObject[IObject.Current].Events[j].Value;
   end;
   if IObject.iObject[IObject.Current].ECount=1 then
   begin
//     StringGrid2.RowCount:=StringGrid2.RowCount+1;
     StringGrid2.RowHeights[StringGrid2.RowCount-2]:=20;
     StringGrid2.RowHeights[StringGrid2.RowCount-1]:=20;
//     StringGrid2.Cells[0,j-1]:=IObject.iObject[IObject.Current].Events[j].iname;
//     StringGrid2.Cells[1,j-1]:=IObject.iObject[IObject.Current].Events[j].Value;
     StringGrid2.Cells[0,0]:=IObject.iObject[IObject.Current].Events[1].iname;
     StringGrid2.Cells[1,0]:=IObject.iObject[IObject.Current].Events[1].Value;
   end else
   begin
     StringGrid2.Cells[0,j-1]:=IObject.iObject[IObject.Current].Events[j].iname;
     StringGrid2.Cells[1,j-1]:=IObject.iObject[IObject.Current].Events[j].Value;
 end;
   end;
 End Else
 Begin
   StringGrid1.Visible:=false;
   StringGrid2.Visible:=false;
   Combobox1.Items.Clear;
   Combobox1.Enabled:=false;
 End;
end;

procedure TObjInspector.TabSheet1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
// ObjInspector.OnPaint(self);
// Combo.Visible:=false;
end;

procedure TObjInspector.ComboBox1Change(Sender: TObject);
begin
  IObject.Current:=ComboBox1.ItemIndex+1;
  ObjInspector.OnPaint(self);
//  
      DesignForm.tek:=DesignForm.Views[IObject.Current];
      DesignFrm.ViewsMouseDown(DesignForm.Tek,TMouseButton(nil),Shift,0,0);
      DesignFrm.ViewsMouseUp(DesignForm.Tek,TMouseButton(nil),Shift,0,0);
end;

procedure TObjInspector.StringGrid2DrawCell(Sender: TObject; Col,
  Row: Integer; Rect: TRect; State: TGridDrawState);
begin
//  Edit2.Visible:=false;
 if ((StringGrid2.Col=Col) and (StringGrid2.Row=Row)) then
 begin
   Tek:=row;
   Edit2.Left:=Rect.Left;
   Edit2.Top:=Rect.Top;
   Edit2.Width:=(Rect.right div 2)-5;
   Edit2.Height:=20;
   Edit2.Parent:=StringGrid2;
   Edit2.Text:=IObject.iObject[IObject.current].Events[tek+1].Value;//IObject.iObject[IObject.current].Properties[row+1].Value;
   Edit2.Visible:=true;
//   Btn.Visible:=false;
//   Combo.Visible:=false;
 end else
 begin
//   StringGrid1.Canvas.FillRect(Rect);
//   Edit.Visible:=false;
//   Combo.Visible:=false;
//      Edit2.Visible:=false;
 end;
end;

procedure TObjInspector.StringGrid1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if (edit.Visible) and (PageControl1.ActivePage=TabSheet1) then
begin
  edit.SetFocus;
end;
if (edit2.Visible) and (PageControl1.ActivePage=TabSheet2) then
begin
  edit2.SetFocus;
end;
end;

procedure TObjInspector.StringGrid2MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if (edit2.Visible) and (PageControl1.ActivePage=TabSheet2) then
begin
  edit2.SetFocus;
end;

end;

procedure TObjInspector.ApplyClick(Sender: TObject);
begin
If GetProp(pText)<>-1 then Views[IObject.Current].Caption:=IObject.iObject[IObject.current].Properties[GetProp(pText)].Value;
If GetProp(pTop)<>-1 then Views[IObject.Current].Top:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pTop)].Value);
If GetProp(pLeft)<>-1 then Views[IObject.Current].Left:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pLeft)].Value);
If GetProp(pWidth)<>-1 then Views[IObject.Current].Width:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pWidth)].Value);
If GetProp(pHeight)<>-1 then Views[IObject.Current].Height:=StrToInt(IObject.iObject[IObject.current].Properties[GetProp(pHeight)].Value);

//  
      DesignForm.tek:=DesignForm.Views[IObject.Current];
      DesignFrm.ViewsMouseDown(DesignForm.Tek,TMouseButton(nil),Shift,0,0);
      DesignFrm.ViewsMouseUp(DesignForm.Tek,TMouseButton(nil),Shift,0,0);
end;

end.
